From f9fed09e96f43e7eab88378fc444c4987933badb Mon Sep 17 00:00:00 2001
From: zhifu gao <zhifu.gzf@alibaba-inc.com>
Date: 星期五, 09 十二月 2022 23:57:51 +0800
Subject: [PATCH] Merge pull request #10 from alibaba-damo-academy/dev

---
 egs_modelscope/common/modelscope_common_finetune.sh |   97 ++++++++++++++++++++++++++++++++++--------------
 1 files changed, 69 insertions(+), 28 deletions(-)

diff --git a/egs_modelscope/common/modelscope_common_finetune.sh b/egs_modelscope/common/modelscope_common_finetune.sh
index 39cd03e..63143c8 100755
--- a/egs_modelscope/common/modelscope_common_finetune.sh
+++ b/egs_modelscope/common/modelscope_common_finetune.sh
@@ -9,6 +9,7 @@
 gpu_inference=true # Whether to perform gpu decoding, set false for cpu decoding
 njob=4 # the number of jobs for each gpu
 train_cmd=utils/run.pl
+infer_cmd=utils/run.pl
 
 # general configuration
 feats_dir="../DATA" #feature output dictionary, for large data
@@ -32,7 +33,7 @@
 lfr_n=6
 
 init_model_name=speech_paraformer-large_asr_nat-zh-cn-16k-common-vocab8404-pytorch  # pre-trained model, download from modelscope during fine-tuning
-model_revision="v1.0.3"     # please do not modify the model revision
+model_revision="v1.0.4"     # please do not modify the model revision
 cmvn_file=init_model/${init_model_name}/am.mvn
 seg_file=init_model/${init_model_name}/seg_dict
 vocab=init_model/${init_model_name}/tokens.txt
@@ -81,7 +82,14 @@
 # you can set gpu num for decoding here
 gpuid_list=$CUDA_VISIBLE_DEVICES  # set gpus for decoding, the same as training stage by default
 ngpu=$(echo $gpuid_list | awk -F "," '{print NF}')
-inference_nj=$[${ngpu}*${njob}]
+
+if ${gpu_inference}; then
+    inference_nj=$[${ngpu}*${njob}]
+    _ngpu=1
+else
+    inference_nj=$njob
+    _ngpu=0
+fi
 
 [ ! -d ${dataset} ] && echo "$0: Training data is required" && exit 1;
 [ ! -f ${dataset}/train/wav.scp ] && [ ! -f ${dataset}/train/text ] && echo "$0: Training data wav.scp or text is not found" && exit 1;
@@ -99,17 +107,17 @@
 feat_test_dir=${feats_dir}/${dumpdir}/test; mkdir -p ${feat_test_dir}
 
 if [ ${stage} -le 1 ] && [ ${stop_stage} -ge 1 ]; then
-    echo "Feature Generation"
+    echo "stage 1: Feature Generation"
     # compute fbank features
     fbankdir=${feats_dir}/fbank
-    utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj --speed_perturb ${speed_perturb} \
+    utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj --sample_frequency ${sample_frequency} --speed_perturb ${speed_perturb} \
         ${dataset}/train ${exp_dir}/exp/make_fbank/train ${fbankdir}/train
     utils/fix_data_feat.sh ${fbankdir}/train
-    utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj \
+    utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj --sample_frequency ${sample_frequency} \
         ${dataset}/dev ${exp_dir}/exp/make_fbank/dev ${fbankdir}/dev
     utils/fix_data_feat.sh ${fbankdir}/dev
     if [ -d "${dataset}/test" ]; then
-        utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj \
+        utils/compute_fbank.sh --cmd "$train_cmd" --nj $nj --sample_frequency ${sample_frequency} \
             ${dataset}/test ${exp_dir}/exp/make_fbank/test ${fbankdir}/test
         utils/fix_data_feat.sh ${fbankdir}/test
     fi
@@ -158,13 +166,14 @@
 # Training Stage
 world_size=$gpu_num  # run on one machine
 if [ ${stage} -le 3 ] && [ ${stop_stage} -ge 3 ]; then
+    echo "stage 3: Training"
     # update asr train config.yaml
     python modelscope_utils/update_config.py --modelscope_config init_model/${init_model_name}/finetune.yaml --finetune_config ${asr_config} --output_config init_model/${init_model_name}/asr_finetune_config.yaml
     finetune_config=init_model/${init_model_name}/asr_finetune_config.yaml
 
     mkdir -p ${exp_dir}/exp/${model_dir}
     mkdir -p ${exp_dir}/exp/${model_dir}/log
-    INIT_FILE=$exp_dir/ddp_init
+    INIT_FILE=${exp_dir}/exp/${model_dir}/ddp_init
     if [ -f $INIT_FILE ];then
         rm -f $INIT_FILE
     fi
@@ -206,26 +215,58 @@
 fi
 
 # Testing Stage
+# Testing Stage
 if [ ${stage} -le 4 ] && [ ${stop_stage} -ge 4 ]; then
-    ./utils/easy_asr_infer.sh \
-        --lang zh \
-        --datadir ${feats_dir} \
-        --feats_type ${feats_type} \
-        --feats_dim ${feats_dim} \
-        --token_type ${token_type} \
-        --gpu_inference ${gpu_inference} \
-        --inference_config "${inference_config}" \
-        --test_sets "${test_sets}" \
-        --token_list $token_list \
-        --asr_exp ${exp_dir}/exp/${model_dir} \
-        --stage 12 \
-        --stop_stage 12 \
-        --scp $scp \
-        --text text \
-        --inference_nj $inference_nj \
-        --njob $njob \
-        --inference_asr_model $inference_asr_model \
-        --gpuid_list $gpuid_list \
-        --mode paraformer
-fi
+    echo "stage 4: Inference"
+    for dset in ${test_sets}; do
+        asr_exp=${exp_dir}/exp/${model_dir}
+        inference_tag="$(basename "${inference_config}" .yaml)"
+        _dir="${asr_exp}/${inference_tag}/${inference_asr_model}/${dset}"
+        _logdir="${_dir}/logdir"
+        if [ -d ${_dir} ]; then
+            echo "${_dir} is already exists. if you want to decode again, please delete this dir first."
+            exit 0
+        fi
+        mkdir -p "${_logdir}"
+        _data="${feats_dir}/${dumpdir}/${dset}"
+        key_file=${_data}/${scp}
+        num_scp_file="$(<${key_file} wc -l)"
+        _nj=$([ $inference_nj -le $num_scp_file ] && echo "$inference_nj" || echo "$num_scp_file")
+        split_scps=
+        for n in $(seq "${_nj}"); do
+            split_scps+=" ${_logdir}/keys.${n}.scp"
+        done
+        # shellcheck disable=SC2086
+        utils/split_scp.pl "${key_file}" ${split_scps}
+        _opts=
+        if [ -n "${inference_config}" ]; then
+            _opts+="--config ${inference_config} "
+        fi
+        ${infer_cmd} --gpu "${_ngpu}" --max-jobs-run "${_nj}" JOB=1:"${_nj}" "${_logdir}"/asr_inference.JOB.log \
+            python -m funasr.bin.asr_inference_launch \
+                --batch_size 1 \
+                --ngpu "${_ngpu}" \
+                --njob ${njob} \
+                --gpuid_list ${gpuid_list} \
+                --data_path_and_name_and_type "${_data}/${scp},speech,${type}" \
+                --key_file "${_logdir}"/keys.JOB.scp \
+                --asr_train_config "${asr_exp}"/config.yaml \
+                --asr_model_file "${asr_exp}"/"${inference_asr_model}" \
+                --output_dir "${_logdir}"/output.JOB \
+                --mode paraformer \
+                ${_opts}
 
+        for f in token token_int score text; do
+            if [ -f "${_logdir}/output.1/1best_recog/${f}" ]; then
+                for i in $(seq "${_nj}"); do
+                    cat "${_logdir}/output.${i}/1best_recog/${f}"
+                done | sort -k1 >"${_dir}/${f}"
+            fi
+        done
+        python utils/proce_text.py ${_dir}/text ${_dir}/text.proc
+        python utils/proce_text.py ${_data}/text ${_data}/text.proc
+        python utils/compute_wer.py ${_data}/text.proc ${_dir}/text.proc ${_dir}/text.cer
+        tail -n 3 ${_dir}/text.cer > ${_dir}/text.cer.txt
+        cat ${_dir}/text.cer.txt
+    done
+fi

--
Gitblit v1.9.1